using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using Syncfusion.Windows.Forms.Grid;

using System.IO;
using System.Xml;
using System.Xml.Serialization;

namespace GDBG_PersistExpandState
{
	/// <summary>
	/// Summary description for Form1.
	/// </summary>
	public class Form1 : System.Windows.Forms.Form
	{
		private Syncfusion.Windows.Forms.Grid.GridDataBoundGrid gridDataBoundGrid1;
		private System.Windows.Forms.Button button1;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public Form1()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			//
			// TODO: Add any constructor code after InitializeComponent call
			//
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.gridDataBoundGrid1 = new Syncfusion.Windows.Forms.Grid.GridDataBoundGrid();
			this.button1 = new System.Windows.Forms.Button();
			((System.ComponentModel.ISupportInitialize)(this.gridDataBoundGrid1)).BeginInit();
			this.SuspendLayout();
			// 
			// gridDataBoundGrid1
			// 
			this.gridDataBoundGrid1.AllowDragSelectedCols = true;
			this.gridDataBoundGrid1.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
				| System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right)));
			this.gridDataBoundGrid1.Location = new System.Drawing.Point(16, 48);
			this.gridDataBoundGrid1.Name = "gridDataBoundGrid1";
			this.gridDataBoundGrid1.OptimizeInsertRemoveCells = true;
			this.gridDataBoundGrid1.ShowCurrentCellBorderBehavior = Syncfusion.Windows.Forms.Grid.GridShowCurrentCellBorder.GrayWhenLostFocus;
			this.gridDataBoundGrid1.Size = new System.Drawing.Size(448, 448);
			this.gridDataBoundGrid1.SmartSizeBox = false;
			this.gridDataBoundGrid1.SortBehavior = Syncfusion.Windows.Forms.Grid.GridSortBehavior.DoubleClick;
			this.gridDataBoundGrid1.TabIndex = 0;
			this.gridDataBoundGrid1.Text = "gridDataBoundGrid1";
			this.gridDataBoundGrid1.UseListChangedEvent = true;
			// 
			// button1
			// 
			this.button1.Location = new System.Drawing.Point(16, 8);
			this.button1.Name = "button1";
			this.button1.Size = new System.Drawing.Size(128, 24);
			this.button1.TabIndex = 1;
			this.button1.Text = "Export";
			this.button1.Click += new System.EventHandler(this.button1_Click);
			// 
			// Form1
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(472, 510);
			this.Controls.Add(this.button1);
			this.Controls.Add(this.gridDataBoundGrid1);
			this.Name = "Form1";
			this.Text = "Form1";
			this.Load += new System.EventHandler(this.Form1_Load);
			((System.ComponentModel.ISupportInitialize)(this.gridDataBoundGrid1)).EndInit();
			this.ResumeLayout(false);

		}
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new Form1());
		}

		DataTable parentTable;
		
		private void Form1_Load(object sender, System.EventArgs e)
		{
			#region get the data
			parentTable = GetParentTable();
			#endregion

			this.gridDataBoundGrid1.DataSource = parentTable;
	 	}

		#region the data

		private int numberParentRows = 20;
	
		 private DataTable GetParentTable()
		{
			DataTable dt = new DataTable("ParentTable");

			
			dt.Columns.Add(new DataColumn("parentID" , typeof(int))); //lower case p
			dt.Columns.Add(new DataColumn("ParentName"));
			dt.Columns.Add(new DataColumn("ParentDec"));

			for(int i = 0; i < numberParentRows; ++i)
			{
				DataRow dr = dt.NewRow();
				dr[0] = i + 100;//.ToString();
				dr[1] = string.Format("parentName{0}", i);
				dr[2] = string.Format("desc{0}", i);
				dt.Rows.Add(dr);
			}

			return dt;
		}

		
		#endregion

		private void button1_Click(object sender, System.EventArgs e)
		{
			string name = @"temp.xml";
			XmlTextWriter xw = new XmlTextWriter(name, System.Text.Encoding.Default);
			xw.Formatting = Formatting.Indented;
			WriteXml(this.gridDataBoundGrid1, xw);
			xw.Close();
		
		}

		private void WriteXml(GridDataBoundGrid grid, XmlTextWriter xw)
		{
			xw.WriteStartElement("MyDataset");
			int iFirstRecordIndex = grid.Binder.PositionToRowIndex(0);  
			int iEndRecordIndex = grid.EnableAddNew ? grid.Model.RowCount - 1: grid.Model.RowCount;
			for(int i= iFirstRecordIndex ;i<= iEndRecordIndex;i++)  
				WriteGridRecord(grid,i,xw);
			xw.WriteEndElement();

		}

		private void WriteGridRecord(GridDataBoundGrid grid,int RowIndex, XmlTextWriter xw)
		{
			xw.WriteStartElement("MyTable");
			foreach(GridBoundColumn  fd in grid.Binder.InternalColumns )
			{
				int ColIndex = grid.Binder.NameToColIndex(fd.MappingName);   
				xw.WriteElementString(fd.MappingName,grid.Model[RowIndex,ColIndex].Text);    
			}
			xw.WriteEndElement();
		}
	}
}
